package com.landray.kmss.sys.attachment.service.spring;

import com.landray.kmss.util.SpringBeanUtil;
import org.apache.http.HttpResponse;
import org.apache.http.impl.client.CloseableHttpClient;
import java.io.InputStream;
import org.apache.commons.io.IOUtils;
import com.landray.kmss.common.model.IBaseModel;
import com.landray.kmss.sys.attachment.model.SysAttMain;
import org.apache.http.client.methods.HttpUriRequest;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.HttpClients;
import java.util.HashMap;
import java.util.Map;
import com.landray.kmss.sys.attachment.model.SysAtt3rdDownloadQueue;
import org.slf4j.LoggerFactory;
import com.landray.kmss.sys.attachment.service.ISysAttMainCoreInnerService;
import org.slf4j.Logger;
import com.landray.kmss.sys.attachment.interfaces.ISysAtt3rdDownloadService;

public class SysAtt3rdFastDownloadServiceImp implements ISysAtt3rdDownloadService
{
    private static final Logger logger;
    private ISysAttMainCoreInnerService sysAttMainService;
    
    static {
        logger = LoggerFactory.getLogger(SysAtt3rdFastDownloadServiceImp.class);
    }
    
    public Map<String, String> download(final SysAtt3rdDownloadQueue queue, final String downloadUrl) throws Exception {
        final Map<String, String> data = new HashMap<String, String>();
        InputStream in = null;
        CloseableHttpClient httpClient = null;
        try {
            httpClient = HttpClients.custom().build();
            final HttpResponse response = httpClient.execute((HttpUriRequest)new HttpGet(downloadUrl));
            in = response.getEntity().getContent();
            final SysAttMain sysAttMain = (SysAttMain)this.getSysAttMainService().findByPrimaryKey(queue.getFdAttMainId());
            sysAttMain.setInputStream(in);
            this.getSysAttMainService().update((IBaseModel)sysAttMain);
            data.put("result", "success");
        }
        catch (final Exception e) {
            SysAtt3rdFastDownloadServiceImp.logger.error("下载第三方文件失败,下载地址={},queueId={},attMainId={}", downloadUrl, queue.getFdId(), queue.getFdAttMainId(), e);
            throw e;
        }
        finally {
            IOUtils.closeQuietly(in);
            if (httpClient != null) {
                httpClient.close();
            }
        }
        IOUtils.closeQuietly(in);
        if (httpClient != null) {
            httpClient.close();
        }
        return data;
    }
    
    public ISysAttMainCoreInnerService getSysAttMainService() {
        if (this.sysAttMainService == null) {
            this.sysAttMainService = (ISysAttMainCoreInnerService)SpringBeanUtil.getBean("sysAttMainService");
        }
        return this.sysAttMainService;
    }
}
